//package com.ningdatech.pmapi.ding.task;
//
//import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
//import com.google.common.collect.Lists;
//import com.ningdatech.basic.model.GenericResult;
//import com.ningdatech.zwdd.client.ZwddAuthClient;
//import com.ningdatech.zwdd.client.ZwddClient;
//import com.ningdatech.zwdd.model.dto.DingOrgInfoDTO;
//import com.ningdatech.zwdd.model.dto.DingScopesV2DTO;
//import com.ningdatech.zwdd.model.dto.PageSubOrganizationCodeDTO;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.stereotype.Component;
//
//import java.util.ArrayList;
//import java.util.List;
//import java.util.Objects;
//import java.util.stream.Collectors;
//
///**
// * @author liuxinxin
// * @date 2023/2/7 上午10:15
// */
//
//@Component
//public class OrganizationBatchGetTask {
//
//    @Autowired
//    private ZwddClient zwddClient;
//
//    @Autowired
//    private ZwddAuthClient zwddAuthClient;
//
//    public OrganizationBatchGetTask() {
//        // 获取通讯录权限范围 获取顶级组织code
//        GenericResult<DingScopesV2DTO> scopesV2Result = zwddClient.getScopesV2();
//        DingScopesV2DTO data = scopesV2Result.getData();
//
//        if (Objects.nonNull(data)) {
//
//        }
//
////        // 根据组织code查询详情获取部门信息
////        List<String> deptVisibleScopes = data.getDeptVisibleScopes();
////        for (String deptVisibleScope : deptVisibleScopes) {
////            GenericResult<DingOrgInfoDTO> organizationByCodeResult = zwddClient.getOrganizationByCode(deptVisibleScope);
////            DingOrgInfoDTO dingOrgInfoDTO = organizationByCodeResult.getData();
//////            dingOrgInfoDTO
////        }
//        List<String> currentAllOrganizationCodeList = new ArrayList<>();
//
//
//        List<String> deptVisibleScopes = data.getDeptVisibleScopes();
//        for (String orgCode : deptVisibleScopes) {
//            if (currentAllOrganizationCodeList.contains(orgCode)) {
////                log.info("已存在组织架构---{}", orgCode);
//                continue;
//            }
//            List<DingOrgInfoTreeDTO> treeDTOList = new ArrayList<>();
//
//            DingOrgInfoTreeDTO childDingOrgInfoTreeDTO = new DingOrgInfoTreeDTO();
//            //设置节点详情
//            if (dingOrgInfoDtos != null && !dingOrgInfoDtos.isEmpty()) {
//                for (DingOrgInfoDTO orgInfo : dingOrgInfoDtos) {
//                    if (orgInfo.getOrganizationCode().equals(orgCode)) {
//                        childDingOrgInfoTreeDTO.setDingOrgInfoDTO(orgInfo);
//                    }
//                }
//            }
//            childDingOrgInfoTreeDTO.setCode(orgCode);
//            childDingOrgInfoTreeDTO.setChildCodes(new ArrayList<>());
//            getDingOrgChild(childDingOrgInfoTreeDTO);
//            treeDTOList.add(childDingOrgInfoTreeDTO);
//
//            if (CollectionUtils.isNotEmpty(treeDTOList)) {
//                List<DingOrganization> saveRecordList = new ArrayList<>();
//                buildSaveRecordList(treeDTOList, saveRecordList);
//
//                // 批量保存
//                if (saveRecordList.size() <= GROUP_SIZE) {
//                    iDingOrganizationService.saveBatch(saveRecordList);
//                } else {
//                    List<List<DingOrganization>> split = Lists.partition(saveRecordList, GROUP_SIZE);
//                    for (List<DingOrganization> segment : split) {
//                        iDingOrganizationService.saveBatch(segment);
//                    }
//                }
//            }
//            log.info("----拉取浙政钉组织结构结束---,顶级code：" + orgCode);
//        }
//    }
//
//
//    private void getDingOrgChild(DingOrgInfoTreeDTO parentDingOrgInfoTreeDTO) {
//        String parentOrgCode = parentDingOrgInfoTreeDTO.getCode();
//        DingOrgInfoDTO orgInfoDTO = parentDingOrgInfoTreeDTO.getDingOrgInfoDTO();
//        boolean leaf = orgInfoDTO.getLeaf();
//        if (!leaf) {
//            int currentPage = 1;
//            int pageSize = 100;
//            PageSubOrganizationCodeDTO pageSubOrganizationCodeDTO =
//                    dingApiClient.pageSubOrganizationCodes(currentPage++, pageSize, parentOrgCode);
//            List<String> subOrganizationCodeList = new ArrayList<>(pageSubOrganizationCodeDTO.getSubOrganizationCodeList());
//            Long totalSize = pageSubOrganizationCodeDTO.getTotalSize();
//
//            while (totalSize > (long) currentPage * pageSize) {
//                PageSubOrganizationCodeDTO subOrganizationCodeDTO = dingApiClient
//                        .pageSubOrganizationCodes(currentPage++, pageSize, parentOrgCode);
//                if (CollectionUtils.isNotEmpty(subOrganizationCodeDTO.getSubOrganizationCodeList())) {
//                    subOrganizationCodeList.addAll(subOrganizationCodeDTO.getSubOrganizationCodeList());
//                }
//            }
//
//            if (CollectionUtils.isNotEmpty(subOrganizationCodeList)) {
//                List<DingOrgInfoDTO> dingOrgInfoDtos = dingApiClient
//                        .listOrganizationsByCodes(subOrganizationCodeList);
//                List<DingOrgInfoTreeDTO> dingOrgInfoTreeDTOList = dingOrgInfoDtos.stream().map(r -> {
//                    DingOrgInfoTreeDTO dingOrgInfoTreeDTO = new DingOrgInfoTreeDTO();
//                    dingOrgInfoTreeDTO.setCode(r.getOrganizationCode());
//                    dingOrgInfoTreeDTO.setDingOrgInfoDTO(r);
//                    dingOrgInfoTreeDTO.setChildCodes(new ArrayList<>());
//                    getDingOrgChild(dingOrgInfoTreeDTO);
//                    return dingOrgInfoTreeDTO;
//                }).collect(Collectors.toList());
//                parentDingOrgInfoTreeDTO.setChildCodes(dingOrgInfoTreeDTOList);
//            }
//
//        }
//    }
//
//
//    private void buildSaveRecordList(List<DingOrgInfoTreeDTO> treeDTOList, List<DingOrganization> saveRecordList) {
//        if (CollectionUtils.isEmpty(treeDTOList)) {
//            return;
//        }
//        for (DingOrgInfoTreeDTO dingOrgInfoTreeDTO : treeDTOList) {
//            DingOrganization saveRecord = new DingOrganization();
//            DingOrgInfoDTO dingOrgInfoDTO = dingOrgInfoTreeDTO.getDingOrgInfoDTO();
//            List<DingOrgInfoTreeDTO> childCodes = dingOrgInfoTreeDTO.getChildCodes();
//            saveRecord.setDeptSort(dingOrgInfoDTO.getDisplayOrder());
//            saveRecord.setEnabled("1");
//            saveRecord.setParentCode(dingOrgInfoDTO.getParentCode());
//            saveRecord.setOrganizationCode(dingOrgInfoDTO.getOrganizationCode());
//            saveRecord.setSubCount((long) dingOrgInfoTreeDTO.getChildCodes().size());
//            saveRecord.setName(dingOrgInfoDTO.getOrganizationName());
//            saveRecordList.add(saveRecord);
//            if (CollectionUtils.isNotEmpty(childCodes)) {
//                buildSaveRecordList(childCodes, saveRecordList);
//            }
//        }
//
//    }
//
//
//}
