package com.ningdatech.pmapi.organization.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDateTime;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 
 * </p>
 *
 * @author Lierbao
 * @since 2023-02-09
 */
@TableName("ding_organization")
@ApiModel(value = "DingOrganization对象", description = "")
public class DingOrganization implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;

    private String institutionLevelCode;

    private String address;

    private String organizationName;

    private Long displayOrder;

    private Long typeName;

    private Integer leaf;

    private LocalDateTime gmtCreate;

    private String typeCode;

    private String divisionCode;

    private String parentName;

    private String parentCode;

    private String organizationCode;

    private String businessStripCodes;

    private String status;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    public String getInstitutionLevelCode() {
        return institutionLevelCode;
    }

    public void setInstitutionLevelCode(String institutionLevelCode) {
        this.institutionLevelCode = institutionLevelCode;
    }
    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }
    public String getOrganizationName() {
        return organizationName;
    }

    public void setOrganizationName(String organizationName) {
        this.organizationName = organizationName;
    }
    public Long getDisplayOrder() {
        return displayOrder;
    }

    public void setDisplayOrder(Long displayOrder) {
        this.displayOrder = displayOrder;
    }
    public Long getTypeName() {
        return typeName;
    }

    public void setTypeName(Long typeName) {
        this.typeName = typeName;
    }
    public Integer getLeaf() {
        return leaf;
    }

    public void setLeaf(Integer leaf) {
        this.leaf = leaf;
    }
    public LocalDateTime getGmtCreate() {
        return gmtCreate;
    }

    public void setGmtCreate(LocalDateTime gmtCreate) {
        this.gmtCreate = gmtCreate;
    }
    public String getTypeCode() {
        return typeCode;
    }

    public void setTypeCode(String typeCode) {
        this.typeCode = typeCode;
    }
    public String getDivisionCode() {
        return divisionCode;
    }

    public void setDivisionCode(String divisionCode) {
        this.divisionCode = divisionCode;
    }
    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }
    public String getParentCode() {
        return parentCode;
    }

    public void setParentCode(String parentCode) {
        this.parentCode = parentCode;
    }
    public String getOrganizationCode() {
        return organizationCode;
    }

    public void setOrganizationCode(String organizationCode) {
        this.organizationCode = organizationCode;
    }
    public String getBusinessStripCodes() {
        return businessStripCodes;
    }

    public void setBusinessStripCodes(String businessStripCodes) {
        this.businessStripCodes = businessStripCodes;
    }
    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    @Override
    public String toString() {
        return "DingOrganization{" +
            "id=" + id +
            ", institutionLevelCode=" + institutionLevelCode +
            ", address=" + address +
            ", organizationName=" + organizationName +
            ", displayOrder=" + displayOrder +
            ", typeName=" + typeName +
            ", leaf=" + leaf +
            ", gmtCreate=" + gmtCreate +
            ", typeCode=" + typeCode +
            ", divisionCode=" + divisionCode +
            ", parentName=" + parentName +
            ", parentCode=" + parentCode +
            ", organizationCode=" + organizationCode +
            ", businessStripCodes=" + businessStripCodes +
            ", status=" + status +
        "}";
    }
}
